unit ADU1;

interface

uses
  PORTINC,//Enthlt die Deklarationen der PORTPAS.DLL
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Edit1: TEdit;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Nullp: Real;
const Neg = 10.2;
      Pos = 10.25;

implementation

{$R *.DFM}

function Zaehler: Double;
var  Zeit : Double;
begin
  RealTime (true);
  DTR (1);
  TimeInitus;
  While(( CTS=1) and (TimeReadus < 50000)) do;
  Zeit:=TimeReadus;
  DTR (0);
  RealTime (false);
  Zaehler := Zeit;
end;

procedure Nullpunkt;
begin
  delay (500);
  Nullp := -(Zaehler/ln(1-Neg/(Pos+Neg)));
  Delay (500);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCom(pchar('com2:9600,N,8,1'));
  DTR(0);
  RTS (1);
  TXD (0);
  Timer1.Enabled := false;
  delay (500);
  Nullp := -(Zaehler/ln(1-Neg/(Pos+Neg)));
  Delay (500);
  Timer1.Enabled := false;
  Nullpunkt;
  Timer1.Enabled := true;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var Ausgabe:String;
    Zeit: Double;
    Spannung:Real;
begin
  Zeit := Zaehler;
  Spannung := (neg+Pos)*(1-exp(-Zeit/Nullp))-Neg;
  Spannung := round(Spannung*100)/100;
  Edit1.Text := floattostr(Spannung) + ' V';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Timer1.Enabled := false;
  Nullpunkt;
  Timer1.Enabled := true;
end;

end.
