unit Temp1;

interface

uses
  PORTINC,//Enthlt die Deklarationen der PORTPAS.DLL
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function Frequenz (Kanal: Integer): Integer;
var Zaehler, alt, Eingang : Integer;
begin
  Zaehler := 0;
  RealTime (true);
  TimeInitus;
  Case Kanal of
  1:   begin
         alt:=CTS;
         while TimeReadus < 1000000 do begin
           Eingang := CTS;
           if Eingang> alt then Zaehler := Zaehler +1;
           Alt := Eingang;
         end;
        end;
  2:    begin
         alt:=DSR;
         while TimeReadus < 1000000 do begin
           Eingang := DSR;
           if Eingang> alt then Zaehler := Zaehler +1;
           Alt := Eingang;
         end;
        end;
  3:    begin
         alt:=RI;
         while TimeReadus < 1000000 do begin
           Eingang := RI;
           if Eingang> alt then Zaehler := Zaehler +1;
           Alt := Eingang;
         end;
        end;
  4:    begin
         alt:=DCD;
         while TimeReadus < 1000000 do begin
           Eingang := DCD;
           if Eingang> alt then Zaehler := Zaehler +1;
           Alt := Eingang;
         end;
        end;
  end;
  Frequenz := Zaehler;
  RealTime (false);
end;

function Feuchte: Real;
var Messfrequenz: Integer;
begin
  Feuchte := 0;
  Messfrequenz := Frequenz(1);
  if Messfrequenz > 4520 then
     Feuchte := 100 - 20 * (Messfrequenz-4520) / (4897-4520);
  if Messfrequenz > 4897 then
     Feuchte := 80 - 20 * (Messfrequenz-4897) / (5262-4897);
  if Messfrequenz > 5262 then
     Feuchte := 60 - 20 * (Messfrequenz-5262) / (5509-5262);
  if Messfrequenz > 5509 then
     Feuchte := 40 - 20 * (Messfrequenz-5509) / (5828-5509);
  if Messfrequenz > 5828 then
     Feuchte := 20 - 20 * (Messfrequenz-5828) / (6027-5828);
end;

function Temperatur: Real;
var Messfrequenz : Integer;
begin
  Messfrequenz := Frequenz(2);
  Temperatur := 10 * (Messfrequenz-2065) / (2230-2065);   if Messfrequenz > 2230 then
     Temperatur := 10 + 10 * (Messfrequenz-2230) / (2475-2230);
  if Messfrequenz > 2475 then
     Temperatur := 20 + 10 * (Messfrequenz-2475) / (2835-2475);
  if Messfrequenz > 2835 then
     Temperatur := 30 + 10 * (Messfrequenz-2835) / (3430-2835);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCom(pchar('com2:9600,N,8,1'));
  Timer1.Interval := 3000;
  Timer1.Enabled := true;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Edit1.Text := FloatToStrF(Temperatur,ffGeneral,3,4) + ' C';
  Edit2.Text := FloatToStrF(Feuchte,ffGeneral,3,4) + ' %';
end;



end.
