unit sinus;   //Fr Delphi3

interface

uses
   PORTINC, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button8BIT: TButton; Button16BIT: TButton;
    TrackBar8Bit: TTrackBar; TrackBar16BIT: TTrackBar;
    TrackBarFREQ: TTrackBar;
    LabelMIN: TLabel;
    LabelMAX: TLabel;
    LabelFREQ: TLabel;
    procedure Button8BITClick(Sender: TObject);
    procedure Button16BITClick(Sender: TObject);
    procedure TrackBarFREQChange(Sender: TObject);
  end;

var Form1: TForm1;

implementation

{$R *.DFM}

var freq:Integer=100;

procedure TForm1.Button8BITClick(Sender: TObject);
CONST RATE=22050;
VAR Size,t,amp:Integer; p:pchar;
begin
     GetMem(p,RATE);
     Size:=RATE;
     Amp:= Trackbar8BIT.Position;
     For t:= 0 to RATE-1 do
     BEGIN
          p[t]:=chr(Round(127+Amp*sin(2*pi*freq*t/RATE)));
     end;
     SOUNDSetRate(Rate);
     SOUNDSetBytes(1);
     SoundOut(p,Size);
     FreeMem(p);
end;

procedure TForm1.Button16BITClick(Sender: TObject);
CONST RATE=22050;
VAR Size,t,amp,val:Integer; p:pchar;
begin
     GetMem(p,RATE*2);
     Size:=RATE;
     Amp:= Trackbar16BIT.Position;
     For t:= 0 to RATE-1 do
     BEGIN
          val:=Round(0+Amp*sin(2*pi*freq*t/RATE));
          p[t*2]:=chr(LO(val));
          p[t*2+1]:=chr(HI(val));
     end;
     SOUNDSetRate(Rate);
     SOUNDSetBytes(2);
     SoundOut(p,Size);
     FreeMem(p);
end;

procedure TForm1.TrackBarFREQChange(Sender: TObject);
begin
freq:= 100+trackbarFREQ.max-trackbarFREQ.position;
labelFREQ.caption:=inttostr(freq)+' Hz';
end;

end.
