;Serielle Schnittstelle des 8051       (COM51.ASM)
;11,059MHz, 9600 Baud
#include 8051.H
         .org 0000H

ANFANG   mov   SP,#60H         ;Stackpointer setzten
INIT     clr   TR1             ;Timer 1 stoppen
         mov   TH1,#0FAH       ;6 bis berlauf: 9600 Baud
         mov   TL1,#0FAH
         anl   TMOD,#0FH       ;Timer1: 8-Bit-Auto-Reload
         orl   TMOD,#20H
         setb  TR1             ;Timer Starten
         mov   SCON,#50H       ;InitRS232
         setb  TI
         orl   PCON,#80H       ;SMOD=1

NEXT     acall EMPF
         mov   P1,A            ;Portausgabe
         anl   P3,#0EFH        ;Strobe-Impuls an P3.4
         orl   P3,#10H
         Mov   A,P1            ;Portzustand lesen
         acall SEND
         sjmp  NEXT

EMPF     jnb   RI,EMPF
         mov   A,SBUF
         clr   RI
         ret

SEND     jnb   TI,SEND
         clr   TI
         mov   SBUF,A
         ret
        .end

