unit BusLauf;

interface

uses PORTINC,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Start: TButton;
    Stop: TButton;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const COM1 : Integer = $03F8;
      COM2 : Integer = $02F8;
      COM3 : Integer = $03E8;
      COM4 : Integer = $02E8;
var Muster: Word;

procedure AddressMode;
begin
  OutPort(COM2+3,$2B); { 8-Bit, 1-Parity, 1 Stopbit }
end;

procedure DataMode;
begin
  OutPort(COM2+3,$3B); { 8-Bit, 0-Parity, 1 Stopbit }
end;

procedure Output16(Daten:Word);
var Dummy: Integer;
begin
  AddressMode;
  SendByte(2);
  Dummy := ReadByte;
  DataMode;
  SendByte (16);
  SendByte (lo(Daten));
  SendByte (0);
  AddressMode;
  SendByte(8);
  Dummy := ReadByte;
  DataMode;
  SendByte (16);
  SendByte (hi(Daten));
  SendByte (0);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCOM (Pchar('COM2:9600,M,8,1'));  {Adressmodus}
  Muster := 1;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  OutPut16(Muster);
  Muster := Muster * 2;
  If Muster = 0 then Muster := 1;
end;

procedure TForm1.StartClick(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
  Timer1.Enabled := false;
end;

end.
